/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlets;


import hibernate.Userdata;
import hibernate.util.HibernateUtil;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import common.Data;
import hibernate.Userstatistic;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author Ani
 */
@WebServlet(name="Game", urlPatterns={"/Game"})
public class Game extends HttpServlet {
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response){
        ObjectInputStream in = null;
        try {
            response.setContentType("application/x-java-serialized-object");
            in = new ObjectInputStream(request.getInputStream());
            ObjectOutputStream out = new ObjectOutputStream(response.getOutputStream());
            Object obj = in.readObject();

            if (obj instanceof String){
                out.writeObject(isUserLoggedIn((String) obj));
            }
            else if (obj instanceof Data){
                out.writeObject(refreshDatabase((Data) obj));
            }

            out.flush();
            out.close();
        } catch (ClassNotFoundException ex) {

        } catch (IOException ex) {

        } catch (Exception ex){

        } finally {
            try {
                in.close();
            } catch (IOException ex) {

            }
        }

    }

    private String isUserLoggedIn(String username){
         Session hibernateSession = HibernateUtil.getSessionFactory().openSession();
         hibernateSession.beginTransaction();
         Userdata ud = (Userdata) hibernateSession.get(Userdata.class, username);

         if (ud==null){
             hibernateSession.close();
             return null;
         }
         hibernateSession.close();
         return ud.getTablename();
    }

    private String refreshDatabase(Data data) throws IOException{
        Session hibernateSession = HibernateUtil.getSessionFactory().openSession();
        Transaction tr = hibernateSession.beginTransaction();

        Userdata ud = (Userdata) hibernateSession.get(Userdata.class, data.getUsername());

         if (ud==null){
             hibernateSession.close();
             return null;
         }

        Userstatistic us = ud.getUserstatistic();

        us.setAllGame(us.getAllGame()+1);
        if (data.getGame()==Data.WINNED){
            us.setWinned(us.getWinned()+1);
        }
        else if (data.getGame()==Data.LOST){
            us.setLost(us.getLost()+1);
        }
        hibernateSession.update(us);
        tr.commit();
        hibernateSession.close();

        return "ok";
    }
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
